"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  PACKAGE_NAME: () => PACKAGE_NAME,
  PACKAGE_VERSION: () => PACKAGE_VERSION,
  PACKAGE_VERSION_MAJOR: () => PACKAGE_VERSION_MAJOR,
  PACKAGE_VERSION_MINOR: () => PACKAGE_VERSION_MINOR,
  PACKAGE_VERSION_PATCH: () => PACKAGE_VERSION_PATCH,
  embed: () => embed2,
  getJsDelivrModule: () => getJsDelivrModule
});
module.exports = __toCommonJS(src_exports);

// package.json
var package_default = {
  name: "@duckdb/duckdb-wasm-shell",
  version: "1.28.1-dev185.0",
  description: "",
  author: "Andre Kohn <kohn.a@outlook.com>",
  license: "MIT",
  repository: {
    type: "git",
    url: "https://github.com/duckdb/duckdb-wasm.git"
  },
  keywords: [
    "sql",
    "duckdb",
    "relational",
    "database",
    "data",
    "query",
    "wasm",
    "analytics",
    "olap",
    "arrow",
    "parquet",
    "json",
    "csv"
  ],
  dependencies: {
    "@duckdb/duckdb-wasm": "^1.28.1-dev185.0",
    xterm: "^5.3.0",
    "xterm-addon-fit": "^0.8.0",
    "xterm-addon-web-links": "^0.9.0",
    "xterm-addon-webgl": "^0.16.0"
  },
  devDependencies: {
    esbuild: "^0.20.1",
    eslint: "^8.56.0",
    "eslint-plugin-jasmine": "^4.1.3",
    "eslint-plugin-react": "^7.34.0",
    jasmine: "^5.1.0",
    "jasmine-core": "^5.1.2",
    "jasmine-spec-reporter": "^7.0.0",
    "make-dir": "^4.0.0",
    prettier: "^3.2.5",
    rimraf: "^5.0.5",
    "wasm-pack": "^0.12.1"
  },
  scripts: {
    "install:wasmpack": "node ../../node_modules/wasm-pack/install.js",
    "build:debug": "node bundle.mjs debug && tsc --emitDeclarationOnly",
    "build:release": "node bundle.mjs release && tsc --emitDeclarationOnly",
    lint: "eslint src"
  },
  files: [
    "dist",
    "!dist/types/test"
  ],
  main: "dist/shell.cjs",
  module: "dist/shell.mjs",
  types: "dist/shell.d.ts",
  jsdelivr: "dist/shell.cjs",
  unpkg: "dist/shell.mjs",
  sideEffects: false,
  exports: {
    "./dist/shell_bg.wasm": "./dist/shell_bg.wasm",
    "./dist/shell.js": "./dist/shell.js",
    "./dist/shell.cjs": "./dist/shell.cjs",
    "./dist/shell.mjs": "./dist/shell.mjs",
    "./dist/shell": "./dist/shell.mjs",
    ".": {
      types: "./dist/shell.d.ts",
      import: "./dist/shell.mjs",
      require: "./dist/shell.cjs"
    }
  }
};

// src/version.ts
var PACKAGE_NAME = package_default.name;
var PACKAGE_VERSION = package_default.version;
var VERSION_PARTS = package_default.version.split(".");
var PACKAGE_VERSION_MAJOR = VERSION_PARTS[0];
var PACKAGE_VERSION_MINOR = VERSION_PARTS[1];
var PACKAGE_VERSION_PATCH = VERSION_PARTS[2];

// src/shell.ts
var duckdb2 = __toESM(require("@duckdb/duckdb-wasm"));

// crate/pkg/shell.js
var import_duckdb_wasm = require("@duckdb/duckdb-wasm");
var import_xterm = require("xterm");
var import_xterm_addon_fit = require("xterm-addon-fit");
var import_xterm_addon_web_links = require("xterm-addon-web-links");
var import_xterm_addon_webgl = require("xterm-addon-webgl");
var import_meta = {};
var wasm;
var heap = new Array(128).fill(void 0);
heap.push(void 0, null, true, false);
function getObject(idx) {
  return heap[idx];
}
var heap_next = heap.length;
function dropObject(idx) {
  if (idx < 132)
    return;
  heap[idx] = heap_next;
  heap_next = idx;
}
function takeObject(idx) {
  const ret = getObject(idx);
  dropObject(idx);
  return ret;
}
function isLikeNone(x) {
  return x === void 0 || x === null;
}
var cachedFloat64Memory0 = null;
function getFloat64Memory0() {
  if (cachedFloat64Memory0 === null || cachedFloat64Memory0.byteLength === 0) {
    cachedFloat64Memory0 = new Float64Array(wasm.memory.buffer);
  }
  return cachedFloat64Memory0;
}
var cachedInt32Memory0 = null;
function getInt32Memory0() {
  if (cachedInt32Memory0 === null || cachedInt32Memory0.byteLength === 0) {
    cachedInt32Memory0 = new Int32Array(wasm.memory.buffer);
  }
  return cachedInt32Memory0;
}
function addHeapObject(obj) {
  if (heap_next === heap.length)
    heap.push(heap.length + 1);
  const idx = heap_next;
  heap_next = heap[idx];
  heap[idx] = obj;
  return idx;
}
var WASM_VECTOR_LEN = 0;
var cachedUint8Memory0 = null;
function getUint8Memory0() {
  if (cachedUint8Memory0 === null || cachedUint8Memory0.byteLength === 0) {
    cachedUint8Memory0 = new Uint8Array(wasm.memory.buffer);
  }
  return cachedUint8Memory0;
}
var cachedTextEncoder = typeof TextEncoder !== "undefined" ? new TextEncoder("utf-8") : { encode: () => {
  throw Error("TextEncoder not available");
} };
var encodeString = typeof cachedTextEncoder.encodeInto === "function" ? function(arg, view) {
  return cachedTextEncoder.encodeInto(arg, view);
} : function(arg, view) {
  const buf = cachedTextEncoder.encode(arg);
  view.set(buf);
  return {
    read: arg.length,
    written: buf.length
  };
};
function passStringToWasm0(arg, malloc, realloc) {
  if (realloc === void 0) {
    const buf = cachedTextEncoder.encode(arg);
    const ptr2 = malloc(buf.length, 1) >>> 0;
    getUint8Memory0().subarray(ptr2, ptr2 + buf.length).set(buf);
    WASM_VECTOR_LEN = buf.length;
    return ptr2;
  }
  let len = arg.length;
  let ptr = malloc(len, 1) >>> 0;
  const mem = getUint8Memory0();
  let offset = 0;
  for (; offset < len; offset++) {
    const code = arg.charCodeAt(offset);
    if (code > 127)
      break;
    mem[ptr + offset] = code;
  }
  if (offset !== len) {
    if (offset !== 0) {
      arg = arg.slice(offset);
    }
    ptr = realloc(ptr, len, len = offset + arg.length * 3, 1) >>> 0;
    const view = getUint8Memory0().subarray(ptr + offset, ptr + len);
    const ret = encodeString(arg, view);
    offset += ret.written;
  }
  WASM_VECTOR_LEN = offset;
  return ptr;
}
function debugString(val) {
  const type = typeof val;
  if (type == "number" || type == "boolean" || val == null) {
    return "".concat(val);
  }
  if (type == "string") {
    return '"'.concat(val, '"');
  }
  if (type == "symbol") {
    const description = val.description;
    if (description == null) {
      return "Symbol";
    } else {
      return "Symbol(".concat(description, ")");
    }
  }
  if (type == "function") {
    const name = val.name;
    if (typeof name == "string" && name.length > 0) {
      return "Function(".concat(name, ")");
    } else {
      return "Function";
    }
  }
  if (Array.isArray(val)) {
    const length = val.length;
    let debug = "[";
    if (length > 0) {
      debug += debugString(val[0]);
    }
    for (let i = 1; i < length; i++) {
      debug += ", " + debugString(val[i]);
    }
    debug += "]";
    return debug;
  }
  const builtInMatches = /\[object ([^\]]+)\]/.exec(toString.call(val));
  let className;
  if (builtInMatches.length > 1) {
    className = builtInMatches[1];
  } else {
    return toString.call(val);
  }
  if (className == "Object") {
    try {
      return "Object(" + JSON.stringify(val) + ")";
    } catch (_) {
      return "Object";
    }
  }
  if (val instanceof Error) {
    return "".concat(val.name, ": ").concat(val.message, "\n").concat(val.stack);
  }
  return className;
}
var cachedTextDecoder = typeof TextDecoder !== "undefined" ? new TextDecoder("utf-8", { ignoreBOM: true, fatal: true }) : { decode: () => {
  throw Error("TextDecoder not available");
} };
if (typeof TextDecoder !== "undefined") {
  cachedTextDecoder.decode();
}
function getStringFromWasm0(ptr, len) {
  ptr = ptr >>> 0;
  return cachedTextDecoder.decode(getUint8Memory0().subarray(ptr, ptr + len));
}
function makeMutClosure(arg0, arg1, dtor, f) {
  const state = { a: arg0, b: arg1, cnt: 1, dtor };
  const real = (...args) => {
    state.cnt++;
    const a = state.a;
    state.a = 0;
    try {
      return f(a, state.b, ...args);
    } finally {
      if (--state.cnt === 0) {
        wasm.__wbindgen_export_2.get(state.dtor)(a, state.b);
      } else {
        state.a = a;
      }
    }
  };
  real.original = state;
  return real;
}
function __wbg_adapter_22(arg0, arg1, arg2) {
  const ret = wasm.wasm_bindgen__convert__closures__invoke1_mut__he15163bc4ac5673d(arg0, arg1, addHeapObject(arg2));
  return ret !== 0;
}
function __wbg_adapter_25(arg0, arg1, arg2) {
  wasm.wasm_bindgen__convert__closures__invoke1_mut__h15601f0fba51bc1c(arg0, arg1, addHeapObject(arg2));
}
function handleError(f, args) {
  try {
    return f.apply(this, args);
  } catch (e) {
    wasm.__wbindgen_exn_store(addHeapObject(e));
  }
}
var cachedUint32Memory0 = null;
function getUint32Memory0() {
  if (cachedUint32Memory0 === null || cachedUint32Memory0.byteLength === 0) {
    cachedUint32Memory0 = new Uint32Array(wasm.memory.buffer);
  }
  return cachedUint32Memory0;
}
function passArray32ToWasm0(arg, malloc) {
  const ptr = malloc(arg.length * 4, 4) >>> 0;
  getUint32Memory0().set(arg, ptr / 4);
  WASM_VECTOR_LEN = arg.length;
  return ptr;
}
function passArray8ToWasm0(arg, malloc) {
  const ptr = malloc(arg.length * 1, 1) >>> 0;
  getUint8Memory0().set(arg, ptr / 1);
  WASM_VECTOR_LEN = arg.length;
  return ptr;
}
function embed(elem, runtime, options) {
  try {
    const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
    wasm.embed(retptr, addHeapObject(elem), addHeapObject(runtime), addHeapObject(options));
    var r0 = getInt32Memory0()[retptr / 4 + 0];
    var r1 = getInt32Memory0()[retptr / 4 + 1];
    if (r1) {
      throw takeObject(r0);
    }
  } finally {
    wasm.__wbindgen_add_to_stack_pointer(16);
  }
}
function write(text) {
  const ptr0 = passStringToWasm0(text, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
  const len0 = WASM_VECTOR_LEN;
  wasm.write(ptr0, len0);
}
function writeln(text) {
  const ptr0 = passStringToWasm0(text, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
  const len0 = WASM_VECTOR_LEN;
  wasm.writeln(ptr0, len0);
}
function resize(_width, _height) {
  wasm.resize(_width, _height);
}
var stack_pointer = 128;
function addBorrowedObject(obj) {
  if (stack_pointer == 1)
    throw new Error("out of js stack");
  heap[--stack_pointer] = obj;
  return stack_pointer;
}
function loadHistory(history, cursor) {
  try {
    wasm.loadHistory(addBorrowedObject(history), cursor);
  } finally {
    heap[stack_pointer++] = void 0;
  }
}
function passInitQueries(queries) {
  const ret = wasm.passInitQueries(addHeapObject(queries));
  return takeObject(ret);
}
function configureDatabase(db) {
  const ret = wasm.configureDatabase(addHeapObject(db));
  return takeObject(ret);
}
function __wbg_adapter_214(arg0, arg1, arg2, arg3) {
  wasm.wasm_bindgen__convert__closures__invoke2_mut__ha576d11aa8b0f76d(arg0, arg1, addHeapObject(arg2), addHeapObject(arg3));
}
var ShellInputContext = Object.freeze({ FileInput: 0, "0": "FileInput" });
var WcWidth = Object.freeze({ Width0: 0, "0": "Width0", Width1: 1, "1": "Width1", Width2: 2, "2": "Width2" });
var DuckDBConfig = class _DuckDBConfig {
  static __wrap(ptr) {
    ptr = ptr >>> 0;
    const obj = Object.create(_DuckDBConfig.prototype);
    obj.__wbg_ptr = ptr;
    return obj;
  }
  __destroy_into_raw() {
    const ptr = this.__wbg_ptr;
    this.__wbg_ptr = 0;
    return ptr;
  }
  free() {
    const ptr = this.__destroy_into_raw();
    wasm.__wbg_duckdbconfig_free(ptr);
  }
  /**
  * @returns {string | undefined}
  */
  get path() {
    try {
      const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
      wasm.duckdbconfig_path(retptr, this.__wbg_ptr);
      var r0 = getInt32Memory0()[retptr / 4 + 0];
      var r1 = getInt32Memory0()[retptr / 4 + 1];
      let v1;
      if (r0 !== 0) {
        v1 = getStringFromWasm0(r0, r1).slice();
        wasm.__wbindgen_free(r0, r1 * 1);
      }
      return v1;
    } finally {
      wasm.__wbindgen_add_to_stack_pointer(16);
    }
  }
  /**
  * @param {string | undefined} path
  */
  set path(path) {
    var ptr0 = isLikeNone(path) ? 0 : passStringToWasm0(path, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len0 = WASM_VECTOR_LEN;
    wasm.duckdbconfig_set_path(this.__wbg_ptr, ptr0, len0);
  }
};
async function __wbg_load(module2, imports) {
  if (typeof Response === "function" && module2 instanceof Response) {
    if (typeof WebAssembly.instantiateStreaming === "function") {
      try {
        return await WebAssembly.instantiateStreaming(module2, imports);
      } catch (e) {
        if (module2.headers.get("Content-Type") != "application/wasm") {
          console.warn("`WebAssembly.instantiateStreaming` failed because your server does not serve wasm with `application/wasm` MIME type. Falling back to `WebAssembly.instantiate` which is slower. Original error:\n", e);
        } else {
          throw e;
        }
      }
    }
    const bytes = await module2.arrayBuffer();
    return await WebAssembly.instantiate(bytes, imports);
  } else {
    const instance = await WebAssembly.instantiate(module2, imports);
    if (instance instanceof WebAssembly.Instance) {
      return { instance, module: module2 };
    } else {
      return instance;
    }
  }
}
function __wbg_get_imports() {
  const imports = {};
  imports.wbg = {};
  imports.wbg.__wbindgen_object_drop_ref = function(arg0) {
    takeObject(arg0);
  };
  imports.wbg.__wbg_getFeatureFlags_9c3df152bef86fb8 = function() {
    return handleError(function(arg0) {
      const ret = getObject(arg0).getFeatureFlags();
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbindgen_number_get = function(arg0, arg1) {
    const obj = getObject(arg1);
    const ret = typeof obj === "number" ? obj : void 0;
    getFloat64Memory0()[arg0 / 8 + 1] = isLikeNone(ret) ? 0 : ret;
    getInt32Memory0()[arg0 / 4 + 0] = !isLikeNone(ret);
  };
  imports.wbg.__wbg_collectFileStatistics_e921aaaeffb34db1 = function() {
    return handleError(function(arg0, arg1, arg2, arg3) {
      const ret = getObject(arg0).collectFileStatistics(getStringFromWasm0(arg1, arg2), arg3 !== 0);
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_exportFileStatistics_6b72eb40ca2eb4d5 = function() {
    return handleError(function(arg0, arg1, arg2) {
      const ret = getObject(arg0).exportFileStatistics(getStringFromWasm0(arg1, arg2));
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_construct_e68e1da98af9f9aa = function(arg0) {
    const ret = new import_xterm.Terminal(getObject(arg0));
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_cols_5c0bdee281fe5dd9 = function(arg0) {
    const ret = getObject(arg0).cols;
    return ret;
  };
  imports.wbg.__wbg_withWebGL_03eecbba7b231a0f = function(arg0) {
    const ret = getObject(arg0).withWebGL;
    return ret;
  };
  imports.wbg.__wbg_attachCustomKeyEventHandler_d9201dcf85a52ecb = function(arg0, arg1) {
    getObject(arg0).attachCustomKeyEventHandler(getObject(arg1));
  };
  imports.wbg.__wbindgen_object_clone_ref = function(arg0) {
    const ret = getObject(arg0);
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_write_d31c366220b675c8 = function(arg0, arg1, arg2) {
    getObject(arg0).write(getStringFromWasm0(arg1, arg2));
  };
  imports.wbg.__wbg_pushInputToHistory_2b5dfdb10ddcc094 = function() {
    return handleError(function(arg0, arg1, arg2) {
      const ret = getObject(arg0).pushInputToHistory(getStringFromWasm0(arg1, arg2));
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_dropFile_377dfecd7aafe02e = function() {
    return handleError(function(arg0, arg1, arg2) {
      const ret = getObject(arg0).dropFile(getStringFromWasm0(arg1, arg2));
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_dropFiles_a67bda4902ba5f36 = function() {
    return handleError(function(arg0) {
      const ret = getObject(arg0).dropFiles();
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_copyFileToBuffer_8303548b5434aa38 = function() {
    return handleError(function(arg0, arg1, arg2) {
      const ret = getObject(arg0).copyFileToBuffer(getStringFromWasm0(arg1, arg2));
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_downloadFile_4cc8985e2c240fec = function() {
    return handleError(function(arg0, arg1, arg2, arg3) {
      const ret = getObject(arg0).downloadFile(getStringFromWasm0(arg1, arg2), takeObject(arg3));
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_globFiles_7fe5c8e5e369e77b = function() {
    return handleError(function(arg0, arg1, arg2) {
      const ret = getObject(arg0).globFiles(getStringFromWasm0(arg1, arg2));
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_pickFiles_cb1fb4d097b8cdab = function() {
    return handleError(function(arg0) {
      const ret = getObject(arg0).pickFiles();
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_open_8d9e16e84b9c860d = function() {
    return handleError(function(arg0, arg1) {
      const ret = getObject(arg0).open(DuckDBConfig.__wrap(arg1));
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_getVersion_6fe922c9d7787e50 = function() {
    return handleError(function(arg0) {
      const ret = getObject(arg0).getVersion();
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbindgen_string_get = function(arg0, arg1) {
    const obj = getObject(arg1);
    const ret = typeof obj === "string" ? obj : void 0;
    var ptr1 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len1 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len1;
    getInt32Memory0()[arg0 / 4 + 0] = ptr1;
  };
  imports.wbg.__wbg_connectInternal_21690058186ac42a = function() {
    return handleError(function(arg0) {
      const ret = getObject(arg0).connectInternal();
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_getPlatformFeatures_0c7441cfa3b5e678 = function() {
    return handleError(function() {
      const ret = (0, import_duckdb_wasm.getPlatformFeatures)();
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_bigInt64Array_b81766f687b4b0b6 = function(arg0) {
    const ret = getObject(arg0).bigInt64Array;
    return ret;
  };
  imports.wbg.__wbg_crossOriginIsolated_f7f727dc97628776 = function(arg0) {
    const ret = getObject(arg0).crossOriginIsolated;
    return ret;
  };
  imports.wbg.__wbg_wasmThreads_cbe2eebf031b26d7 = function(arg0) {
    const ret = getObject(arg0).wasmThreads;
    return ret;
  };
  imports.wbg.__wbg_wasmSIMD_f2cbc78c82c4d673 = function(arg0) {
    const ret = getObject(arg0).wasmSIMD;
    return ret;
  };
  imports.wbg.__wbg_wasmBulkMemory_51a6e2786de28fdc = function(arg0) {
    const ret = getObject(arg0).wasmBulkMemory;
    return ret;
  };
  imports.wbg.__wbg_wasmExceptions_f629aff7d2e90cd3 = function(arg0) {
    const ret = getObject(arg0).wasmExceptions;
    return ret;
  };
  imports.wbg.__wbg_runQuery_41cfa048b61675e2 = function() {
    return handleError(function(arg0, arg1, arg2, arg3) {
      const ret = getObject(arg0).runQuery(arg1 >>> 0, getStringFromWasm0(arg2, arg3));
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_tokenize_f167882593146b7d = function() {
    return handleError(function(arg0, arg1, arg2) {
      const ret = getObject(arg0).tokenize(getStringFromWasm0(arg1, arg2));
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_offsets_fc2b1a7bf689ba81 = function(arg0, arg1) {
    const ret = getObject(arg1).offsets;
    const ptr1 = passArray32ToWasm0(ret, wasm.__wbindgen_malloc);
    const len1 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len1;
    getInt32Memory0()[arg0 / 4 + 0] = ptr1;
  };
  imports.wbg.__wbg_types_b5d339a3bb88320b = function(arg0, arg1) {
    const ret = getObject(arg1).types;
    const ptr1 = passArray8ToWasm0(ret, wasm.__wbindgen_malloc);
    const len1 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len1;
    getInt32Memory0()[arg0 / 4 + 0] = ptr1;
  };
  imports.wbg.__wbg_readClipboardText_f71f3b3a53a23822 = function() {
    return handleError(function(arg0) {
      const ret = getObject(arg0).readClipboardText();
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_focus_909df7c111b58b83 = function(arg0) {
    getObject(arg0).focus();
  };
  imports.wbg.__wbg_fit_cdd1076e3e5970b7 = function(arg0) {
    getObject(arg0).fit();
  };
  imports.wbg.__wbg_log_8bb2c010ce15af48 = function(arg0, arg1) {
    console.log(getStringFromWasm0(arg0, arg1));
  };
  imports.wbg.__wbg_error_a84695ce32854879 = function(arg0, arg1) {
    console.error(getStringFromWasm0(arg0, arg1));
  };
  imports.wbg.__wbg_warn_d85b304f0e70f5ac = function(arg0, arg1) {
    console.warn(getStringFromWasm0(arg0, arg1));
  };
  imports.wbg.__wbg_static_accessor_PACKAGE_NAME_0af717684e189e55 = function(arg0) {
    const ret = import_duckdb_wasm.PACKAGE_NAME;
    const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len1;
    getInt32Memory0()[arg0 / 4 + 0] = ptr1;
  };
  imports.wbg.__wbg_static_accessor_PACKAGE_VERSION_549ba11794cf5003 = function(arg0) {
    const ret = import_duckdb_wasm.PACKAGE_VERSION;
    const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len1;
    getInt32Memory0()[arg0 / 4 + 0] = ptr1;
  };
  imports.wbg.__wbg_new_79cc836771d68198 = function() {
    const ret = new import_xterm_addon_fit.FitAddon();
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_instanceof_WebLinksAddon_fbcf4efb54881c53 = function(arg0) {
    let result;
    try {
      result = getObject(arg0) instanceof import_xterm_addon_web_links.WebLinksAddon;
    } catch (e) {
      result = false;
    }
    const ret = result;
    return ret;
  };
  imports.wbg.__wbg_instanceof_WebglAddon_c39f68697a31af73 = function(arg0) {
    let result;
    try {
      result = getObject(arg0) instanceof import_xterm_addon_webgl.WebglAddon;
    } catch (e) {
      result = false;
    }
    const ret = result;
    return ret;
  };
  imports.wbg.__wbg_setallowProposedApi_0147ac2b5a9906b3 = function(arg0, arg1) {
    getObject(arg0).allowProposedApi = arg1 !== 0;
  };
  imports.wbg.__wbg_setcursorBlink_8a3f7244eb29b1f6 = function(arg0, arg1) {
    getObject(arg0).cursorBlink = arg1 !== 0;
  };
  imports.wbg.__wbg_setcursorWidth_55abde268dea1312 = function(arg0, arg1) {
    getObject(arg0).cursorWidth = arg1 >>> 0;
  };
  imports.wbg.__wbg_setdrawBoldTextInBrightColors_4f711243dff6df11 = function(arg0, arg1) {
    getObject(arg0).drawBoldTextInBrightColors = arg1 !== 0;
  };
  imports.wbg.__wbg_setfontSize_11962e753390bde1 = function(arg0, arg1) {
    getObject(arg0).fontSize = arg1 >>> 0;
  };
  imports.wbg.__wbg_setfontFamily_a0645fa4f7aaaf21 = function(arg0, arg1, arg2) {
    getObject(arg0).fontFamily = getStringFromWasm0(arg1, arg2);
  };
  imports.wbg.__wbg_setrightClickSelectsWord_ede48f0595cd3fed = function(arg0, arg1) {
    getObject(arg0).rightClickSelectsWord = arg1 !== 0;
  };
  imports.wbg.__wbg_setrows_6b947e6079c486dc = function(arg0, arg1) {
    getObject(arg0).rows = arg1 >>> 0;
  };
  imports.wbg.__wbg_settheme_4e67878b7d6cc0fc = function(arg0, arg1) {
    getObject(arg0).theme = getObject(arg1);
  };
  imports.wbg.__wbg_setforeground_87dc40b78955df05 = function(arg0, arg1, arg2) {
    getObject(arg0).foreground = getStringFromWasm0(arg1, arg2);
  };
  imports.wbg.__wbg_setbackground_550386b829ec5c24 = function(arg0, arg1, arg2) {
    getObject(arg0).background = getStringFromWasm0(arg1, arg2);
  };
  imports.wbg.__wbg_setbrightYellow_deb3fbc58aa44642 = function(arg0, arg1, arg2) {
    getObject(arg0).brightYellow = getStringFromWasm0(arg1, arg2);
  };
  imports.wbg.__wbg_open_7d3a0690ea9e5a45 = function(arg0, arg1) {
    getObject(arg0).open(takeObject(arg1));
  };
  imports.wbg.__wbg_loadAddon_1bfe744e6f456990 = function(arg0, arg1) {
    getObject(arg0).loadAddon(takeObject(arg1));
  };
  imports.wbg.__wbg_new_92aa50f448dac851 = function(arg0, arg1, arg2) {
    const ret = new import_xterm_addon_web_links.WebLinksAddon(getObject(arg0), getObject(arg1), arg2 === 16777215 ? void 0 : arg2 !== 0);
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_new_70821bf9dbd17152 = function(arg0) {
    const ret = new import_xterm_addon_webgl.WebglAddon(arg0 === 16777215 ? void 0 : arg0 !== 0);
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_disconnect_d9855433758f0afc = function() {
    return handleError(function(arg0, arg1) {
      const ret = getObject(arg0).disconnect(arg1 >>> 0);
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbindgen_json_serialize = function(arg0, arg1) {
    const obj = getObject(arg1);
    const ret = JSON.stringify(obj === void 0 ? null : obj);
    const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len1;
    getInt32Memory0()[arg0 / 4 + 0] = ptr1;
  };
  imports.wbg.__wbindgen_cb_drop = function(arg0) {
    const obj = takeObject(arg0).original;
    if (obj.cnt-- == 1) {
      obj.a = 0;
      return true;
    }
    const ret = false;
    return ret;
  };
  imports.wbg.__wbg_fontFamily_204223b3338f8381 = function(arg0, arg1) {
    const ret = getObject(arg1).fontFamily;
    const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len1;
    getInt32Memory0()[arg0 / 4 + 0] = ptr1;
  };
  imports.wbg.__wbg_backgroundColor_17a9784f0207d5b0 = function(arg0, arg1) {
    const ret = getObject(arg1).backgroundColor;
    const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len1;
    getInt32Memory0()[arg0 / 4 + 0] = ptr1;
  };
  imports.wbg.__wbg_blockStats_14f17a14c4573f3d = function(arg0) {
    const ret = getObject(arg0).blockStats;
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_totalFileWrites_1b38029d29f47d43 = function(arg0) {
    const ret = getObject(arg0).totalFileWrites;
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_totalFileReadsAhead_02c25545b2f63323 = function(arg0) {
    const ret = getObject(arg0).totalFileReadsAhead;
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_totalFileReadsCold_304476ed0c49e111 = function(arg0) {
    const ret = getObject(arg0).totalFileReadsCold;
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_totalFileReadsCached_2e8edfe7dbf14351 = function(arg0) {
    const ret = getObject(arg0).totalFileReadsCached;
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_totalPageAccesses_2f654448ea273878 = function(arg0) {
    const ret = getObject(arg0).totalPageAccesses;
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_totalPageLoads_1ce10deb8828d935 = function(arg0) {
    const ret = getObject(arg0).totalPageLoads;
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_blockSize_77bc4e968a2e845a = function(arg0) {
    const ret = getObject(arg0).blockSize;
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_new_abda76e883ba8a5f = function() {
    const ret = new Error();
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_stack_658279fe44541cf6 = function(arg0, arg1) {
    const ret = getObject(arg1).stack;
    const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len1;
    getInt32Memory0()[arg0 / 4 + 0] = ptr1;
  };
  imports.wbg.__wbg_error_f851667af71bcfc6 = function(arg0, arg1) {
    let deferred0_0;
    let deferred0_1;
    try {
      deferred0_0 = arg0;
      deferred0_1 = arg1;
      console.error(getStringFromWasm0(arg0, arg1));
    } finally {
      wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
    }
  };
  imports.wbg.__wbg_instanceof_Window_9029196b662bc42a = function(arg0) {
    let result;
    try {
      result = getObject(arg0) instanceof Window;
    } catch (e) {
      result = false;
    }
    const ret = result;
    return ret;
  };
  imports.wbg.__wbg_performance_2c295061c8b01e0b = function(arg0) {
    const ret = getObject(arg0).performance;
    return isLikeNone(ret) ? 0 : addHeapObject(ret);
  };
  imports.wbg.__wbg_type_4197dff653b7d208 = function(arg0, arg1) {
    const ret = getObject(arg1).type;
    const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len1;
    getInt32Memory0()[arg0 / 4 + 0] = ptr1;
  };
  imports.wbg.__wbg_now_0cfdc90c97d0c24b = function(arg0) {
    const ret = getObject(arg0).now();
    return ret;
  };
  imports.wbg.__wbg_ctrlKey_582686fb2263dd3c = function(arg0) {
    const ret = getObject(arg0).ctrlKey;
    return ret;
  };
  imports.wbg.__wbg_metaKey_43193b7cc99f8914 = function(arg0) {
    const ret = getObject(arg0).metaKey;
    return ret;
  };
  imports.wbg.__wbg_key_8aeaa079126a9cc7 = function(arg0, arg1) {
    const ret = getObject(arg1).key;
    const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len1;
    getInt32Memory0()[arg0 / 4 + 0] = ptr1;
  };
  imports.wbg.__wbg_get_44be0491f933a435 = function(arg0, arg1) {
    const ret = getObject(arg0)[arg1 >>> 0];
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_length_fff51ee6522a1a18 = function(arg0) {
    const ret = getObject(arg0).length;
    return ret;
  };
  imports.wbg.__wbg_newnoargs_581967eacc0e2604 = function(arg0, arg1) {
    const ret = new Function(getStringFromWasm0(arg0, arg1));
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_call_cb65541d95d71282 = function() {
    return handleError(function(arg0, arg1) {
      const ret = getObject(arg0).call(getObject(arg1));
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_new_b51585de1b234aff = function() {
    const ret = new Object();
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_self_1ff1d729e9aae938 = function() {
    return handleError(function() {
      const ret = self.self;
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_window_5f4faef6c12b79ec = function() {
    return handleError(function() {
      const ret = window.window;
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_globalThis_1d39714405582d3c = function() {
    return handleError(function() {
      const ret = globalThis.globalThis;
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_global_651f05c6a0944d1c = function() {
    return handleError(function() {
      const ret = global.global;
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbindgen_is_undefined = function(arg0) {
    const ret = getObject(arg0) === void 0;
    return ret;
  };
  imports.wbg.__wbg_new_d258248ed531ff54 = function(arg0, arg1) {
    const ret = new Error(getStringFromWasm0(arg0, arg1));
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_message_48bacc5ea57d74ee = function(arg0) {
    const ret = getObject(arg0).message;
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_toString_1c056108b87ba68b = function(arg0) {
    const ret = getObject(arg0).toString();
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_call_01734de55d61e11d = function() {
    return handleError(function(arg0, arg1, arg2) {
      const ret = getObject(arg0).call(getObject(arg1), getObject(arg2));
      return addHeapObject(ret);
    }, arguments);
  };
  imports.wbg.__wbg_getTimezoneOffset_8aee3445f323973e = function(arg0) {
    const ret = getObject(arg0).getTimezoneOffset();
    return ret;
  };
  imports.wbg.__wbg_newwithyearmonthdayhrminsec_b540984d0081e7ed = function(arg0, arg1, arg2, arg3, arg4, arg5) {
    const ret = new Date(arg0 >>> 0, arg1, arg2, arg3, arg4, arg5);
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_new_43f1b47c28813cbd = function(arg0, arg1) {
    try {
      var state0 = { a: arg0, b: arg1 };
      var cb0 = (arg02, arg12) => {
        const a = state0.a;
        state0.a = 0;
        try {
          return __wbg_adapter_214(a, state0.b, arg02, arg12);
        } finally {
          state0.a = a;
        }
      };
      const ret = new Promise(cb0);
      return addHeapObject(ret);
    } finally {
      state0.a = state0.b = 0;
    }
  };
  imports.wbg.__wbg_resolve_53698b95aaf7fcf8 = function(arg0) {
    const ret = Promise.resolve(getObject(arg0));
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_then_f7e06ee3c11698eb = function(arg0, arg1) {
    const ret = getObject(arg0).then(getObject(arg1));
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_then_b2267541e2a73865 = function(arg0, arg1, arg2) {
    const ret = getObject(arg0).then(getObject(arg1), getObject(arg2));
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_buffer_085ec1f694018c4f = function(arg0) {
    const ret = getObject(arg0).buffer;
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_new_8125e318e6245eed = function(arg0) {
    const ret = new Uint8Array(getObject(arg0));
    return addHeapObject(ret);
  };
  imports.wbg.__wbg_set_5cf90238115182c3 = function(arg0, arg1, arg2) {
    getObject(arg0).set(getObject(arg1), arg2 >>> 0);
  };
  imports.wbg.__wbg_length_72e2208bbc0efc61 = function(arg0) {
    const ret = getObject(arg0).length;
    return ret;
  };
  imports.wbg.__wbindgen_debug_string = function(arg0, arg1) {
    const ret = debugString(getObject(arg1));
    const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len1;
    getInt32Memory0()[arg0 / 4 + 0] = ptr1;
  };
  imports.wbg.__wbindgen_throw = function(arg0, arg1) {
    throw new Error(getStringFromWasm0(arg0, arg1));
  };
  imports.wbg.__wbindgen_memory = function() {
    const ret = wasm.memory;
    return addHeapObject(ret);
  };
  imports.wbg.__wbindgen_closure_wrapper582 = function(arg0, arg1, arg2) {
    const ret = makeMutClosure(arg0, arg1, 187, __wbg_adapter_22);
    return addHeapObject(ret);
  };
  imports.wbg.__wbindgen_closure_wrapper979 = function(arg0, arg1, arg2) {
    const ret = makeMutClosure(arg0, arg1, 208, __wbg_adapter_25);
    return addHeapObject(ret);
  };
  return imports;
}
function __wbg_init_memory(imports, maybe_memory) {
}
function __wbg_finalize_init(instance, module2) {
  wasm = instance.exports;
  __wbg_init.__wbindgen_wasm_module = module2;
  cachedFloat64Memory0 = null;
  cachedInt32Memory0 = null;
  cachedUint32Memory0 = null;
  cachedUint8Memory0 = null;
  wasm.__wbindgen_start();
  return wasm;
}
async function __wbg_init(input) {
  if (wasm !== void 0)
    return wasm;
  if (typeof input === "undefined") {
    input = new URL("shell_bg.wasm", import_meta.url);
  }
  const imports = __wbg_get_imports();
  if (typeof input === "string" || typeof Request === "function" && input instanceof Request || typeof URL === "function" && input instanceof URL) {
    input = fetch(input);
  }
  __wbg_init_memory(imports);
  const { instance, module: module2 } = await __wbg_load(await input, imports);
  return __wbg_finalize_init(instance, module2);
}
var shell_default = __wbg_init;

// src/utils/history_store.ts
var DB_VERSION = 4;
var DB_NAME = "DUCKDB_WASM_SHELL_HISTORY";
var TABLE_LOG_INFO = "LOG_INFO";
var TABLE_LOG_ENTRIES = "LOG_ENTRIES";
var HISTORY_SIZE_SHIFT = 10;
var HistoryStore = class {
  constructor() {
    this._idbFactory = window.indexedDB;
    this._idb = null;
    this._nextEntryKey = 0;
    this._entryCount = 0;
  }
  /// Load entire history
  async load() {
    if (this._entryCount == 0)
      return [[], 0];
    const tx = this._idb.transaction([TABLE_LOG_ENTRIES, TABLE_LOG_INFO], "readwrite");
    const logs = tx.objectStore(TABLE_LOG_ENTRIES);
    const cursor = logs.openCursor();
    return await new Promise((resolve, reject) => {
      const results = [];
      cursor.onsuccess = (event) => {
        const req = event.target;
        if (req.result != null) {
          results.push(req.result.value.input);
          req.result.continue();
        } else {
          resolve([results, Math.min(this._nextEntryKey, 1 << HISTORY_SIZE_SHIFT)]);
        }
      };
      cursor.onerror = reject;
    });
  }
  /// Open the indexeddb database
  async open() {
    await new Promise((resolve, reject) => {
      const req = this._idbFactory.open(DB_NAME, DB_VERSION);
      req.onupgradeneeded = (ev) => {
        const openReq = ev.target;
        const idb = openReq.result;
        const tx = openReq.transaction;
        this.createSchema(idb);
        tx.oncomplete = () => resolve(idb);
        tx.onerror = (err) => reject(err);
      };
      req.onsuccess = (_) => {
        this._idb = req.result;
        resolve(null);
      };
      req.onerror = (err) => reject(err);
    }).catch((e) => console.warn("Unable to initialize indexedDB, no history persistence"));
    await this.loadMetadata();
  }
  /// Load the log metadata (if persisted)
  async loadMetadata() {
    if (!this._idb)
      return;
    const entry = await new Promise((resolve, _reject) => {
      const tx = this._idb.transaction([TABLE_LOG_INFO]);
      const logInfo = tx.objectStore(TABLE_LOG_INFO);
      const req = logInfo.get(0);
      req.onsuccess = (e) => resolve(e.target.result || null);
      req.onerror = (e) => {
        console.warn(e);
        resolve(null);
      };
    });
    this._nextEntryKey = (entry == null ? void 0 : entry.nextEntryKey) || 0;
    this._entryCount = (entry == null ? void 0 : entry.entryCount) || 0;
  }
  /// Create the store schema
  createSchema(idb) {
    if (idb.objectStoreNames.contains(TABLE_LOG_INFO)) {
      idb.deleteObjectStore(TABLE_LOG_INFO);
    }
    if (idb.objectStoreNames.contains(TABLE_LOG_ENTRIES)) {
      idb.deleteObjectStore(TABLE_LOG_ENTRIES);
    }
    idb.createObjectStore(TABLE_LOG_INFO, {
      keyPath: "key"
    });
    idb.createObjectStore(TABLE_LOG_ENTRIES, {
      keyPath: "key"
    });
  }
  /// Reset the indexeddb
  async reset() {
    var _a;
    (_a = this._idb) == null ? void 0 : _a.close();
    this._idb = null;
    this._idbFactory.deleteDatabase(DB_NAME);
    await this.open();
  }
  /// Push a new entry
  async push(input) {
    if (!this._idb)
      return;
    const entryKey = this._nextEntryKey++ & (1 << HISTORY_SIZE_SHIFT) - 1;
    this._entryCount = Math.min(this._entryCount + 1, 1 << HISTORY_SIZE_SHIFT);
    const tx = this._idb.transaction([TABLE_LOG_ENTRIES, TABLE_LOG_INFO], "readwrite");
    const logInfo = tx.objectStore(TABLE_LOG_INFO);
    const logEntries = tx.objectStore(TABLE_LOG_ENTRIES);
    await Promise.all([
      new Promise((resolve, reject) => {
        const r = logEntries.put({
          key: entryKey,
          when: /* @__PURE__ */ new Date(),
          input
        });
        r.onsuccess = resolve;
        r.onerror = reject;
      }),
      new Promise((resolve, reject) => {
        const r = logInfo.put({
          key: 0,
          nextEntryKey: this._nextEntryKey,
          entryCount: this._entryCount
        });
        r.onsuccess = resolve;
        r.onerror = reject;
      })
    ]);
  }
};

// src/utils/files.ts
var duckdb = __toESM(require("@duckdb/duckdb-wasm"));
function pickFilesForFileReader(db) {
  return new Promise((resolve, _reject) => {
    const input = document.createElement("input");
    input.type = "file";
    let closed = false;
    const finish = async () => {
      console.log(input.files);
      closed = true;
      const files = input.files;
      for (let i = 0; i < files.length; ++i) {
        const file = files.item(i);
        await db.dropFile(file.name);
        await db.registerFileHandle(file.name, file, duckdb.DuckDBDataProtocol.BROWSER_FILEREADER, true);
      }
      resolve(files.length);
    };
    const deferredFinish = async () => {
      window.removeEventListener("focus", deferredFinish);
      if (closed) {
        return;
      }
      await new Promise((r) => setTimeout(r, 1e3));
      if (!closed) {
        await finish();
      }
    };
    input.onchange = async function() {
      window.removeEventListener("focus", deferredFinish);
      await finish();
    };
    input.onclick = async function() {
      window.addEventListener("focus", deferredFinish);
    };
    input.click();
  });
}
async function pickFiles(db) {
  return await pickFilesForFileReader(db);
}

// src/shell.ts
var hasWebGL = () => {
  if (duckdb2.isSafari()) {
    return false;
  }
  const canvas = document.createElement("canvas");
  const supports = "probablySupportsContext" in canvas ? "probablySupportsContext" : "supportsContext";
  if (supports in canvas) {
    return canvas[supports]("webgl2");
  }
  return "WebGL2RenderingContext" in window;
};
var ShellRuntime = class {
  constructor(container) {
    this.container = container;
    this.database = null;
    this.history = new HistoryStore();
    this.resizeHandler = (_event) => {
      const rect = container.getBoundingClientRect();
      resize(rect.width, rect.height);
    };
    this.hash = "";
  }
  async pickFiles() {
    if (this.database == null) {
      console.warn("database is not initialized");
      return 0;
    }
    return await pickFiles(this.database);
  }
  async downloadFile(name, buffer) {
    const blob = new Blob([buffer]);
    const link = document.createElement("a");
    link.href = URL.createObjectURL(blob);
    link.download = name;
    link.click();
  }
  async readClipboardText() {
    return await navigator.clipboard.readText();
  }
  async writeClipboardText(value) {
    return await navigator.clipboard.writeText(value);
  }
  async pushInputToHistory(value) {
    const encode = encodeURIComponent(extraswaps(value));
    if (this.hash === "")
      this.hash = "queries=v0";
    this.hash += ",";
    this.hash += encode;
    if (window.location.hash.startsWith("#savequeries"))
      window.location.hash = "savequeries&" + this.hash;
    const a = document.getElementById("hashencoded");
    if (a && a instanceof HTMLAnchorElement)
      a.href = "/#" + this.hash;
    this.history.push(value);
  }
};
function formatBytes(value) {
  const [multiple, k, suffix] = [1e3, "k", "B"];
  const exp = Math.log(value) / Math.log(multiple) | 0;
  const size = Number((value / Math.pow(multiple, exp)).toFixed(2));
  return "".concat(size, " ").concat(exp ? "".concat(k, "MGTPEZY")[exp - 1] + suffix : "byte".concat(size !== 1 ? "s" : ""));
}
function extraswaps(input) {
  let res = "";
  for (let i = 0; i < input.length; i++) {
    if (input[i] == " ")
      res += "-";
    else if (input[i] == "-")
      res += " ";
    else if (input[i] == ";")
      res += "~";
    else if (input[i] == "~")
      res += ";";
    else
      res += input[i];
  }
  return res;
}
async function embed2(props) {
  var _a, _b;
  await shell_default(props.shellModule);
  const runtime = new ShellRuntime(props.container);
  embed(props.container, runtime, {
    fontFamily: (_a = props.fontFamily) != null ? _a : "monospace",
    backgroundColor: (_b = props.backgroundColor) != null ? _b : "#333",
    withWebGL: hasWebGL()
  });
  props.container.onresize = runtime.resizeHandler;
  const TERM_BOLD = "\x1B[1m";
  const TERM_NORMAL = "\x1B[m";
  const TERM_CLEAR = "\x1B[2K\r";
  const progressHandler = (progress) => {
    if (progress.bytesTotal > 0) {
      const blocks = Math.max(Math.min(Math.floor(progress.bytesLoaded / progress.bytesTotal * 10), 10), 0);
      const bar = "".concat("#".repeat(blocks)).concat("-".repeat(10 - blocks));
      write("".concat(TERM_CLEAR).concat(TERM_BOLD, "[ RUN ]").concat(TERM_NORMAL, " Loading ").concat(bar));
    } else {
      write("".concat(TERM_CLEAR).concat(TERM_BOLD, "[ RUN ]").concat(TERM_NORMAL, " Loading ").concat(formatBytes(progress.bytesLoaded)));
    }
  };
  writeln("".concat(TERM_BOLD, "[ RUN ]").concat(TERM_NORMAL, " Instantiating DuckDB"));
  runtime.database = await props.resolveDatabase(progressHandler);
  writeln("".concat(TERM_CLEAR).concat(TERM_BOLD, "[ OK  ]").concat(TERM_NORMAL, " Instantiating DuckDB"));
  const step = async (label, work) => {
    writeln("".concat(TERM_BOLD, "[ RUN ]").concat(TERM_NORMAL, " ").concat(label));
    await work();
    writeln("".concat(TERM_BOLD, "[ OK  ]").concat(TERM_NORMAL, " ").concat(label));
  };
  await step("Loading Shell History", async () => {
    await runtime.history.open();
    const [hist, histCursor] = await runtime.history.load();
    loadHistory(hist, histCursor);
  });
  await step("Attaching Shell", async () => {
    configureDatabase(runtime.database);
  });
  const hash = window.location.hash;
  const splits = hash.split(",");
  const sqls = [];
  for (let i = 1; i < splits.length; i++) {
    sqls.push(extraswaps(decodeURIComponent(splits[i])));
  }
  await step("Rewinding history!", async () => {
    passInitQueries(sqls);
  });
}

// src/platform.ts
function getJsDelivrModule() {
  const jsdelivr_dist_url = "https://cdn.jsdelivr.net/npm/".concat(PACKAGE_NAME, "@").concat(PACKAGE_VERSION, "/dist/");
  return new URL("".concat(jsdelivr_dist_url, "dist/shell_bg.wasm"));
}
//# sourceMappingURL=shell.cjs.map
